"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Checkbox = void 0;

var _react = _interopRequireWildcard(require("react"));

var _translation_utils = require("../../translation_utils");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function () { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

let Checkbox = ({
  schemaTypeName,
  name,
  defaultValue,
  styles = {},
  field
}, ref) => {
  const defaultChecked = defaultValue !== 'false' && defaultValue;
  return /*#__PURE__*/_react.default.createElement("div", {
    key: name,
    className: styles.checkboxWrap
  }, /*#__PURE__*/_react.default.createElement("input", {
    key: "val",
    id: name,
    type: "checkbox",
    name: name,
    ref: ref,
    defaultChecked: defaultChecked,
    className: styles.checkbox
  }), /*#__PURE__*/_react.default.createElement("label", {
    key: "label",
    htmlFor: name,
    className: styles.checkboxLabel
  }, (0, _translation_utils.trModel)(schemaTypeName, name)));
};

exports.Checkbox = Checkbox;
exports.Checkbox = Checkbox = (0, _react.forwardRef)(Checkbox);