"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.InputArrayTable = void 0;

var _react = _interopRequireDefault(require("react"));

var _translation_utils = require("../../translation_utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// import { renderLectures } from './renderLectures'
const renderRemove = ({
  idx,
  closeButton
}) => /*#__PURE__*/_react.default.createElement("td", {
  key: idx
}, closeButton);

const renderTableHeader = ({
  schema
}) => {
  const subType = schema.getType();
  const schemaDef = schema.getSchema();
  const fields = Object.keys(schemaDef);
  return /*#__PURE__*/_react.default.createElement("tr", null, /*#__PURE__*/_react.default.createElement("th", null), fields.map(sub => /*#__PURE__*/_react.default.createElement("th", {
    key: sub
  }, (0, _translation_utils.trField)(subType, sub))));
};

const renderItems = ({
  items
}) => items.map(({
  idx,
  closeButton,
  inputs
}) => {
  const tdedInputs = inputs && inputs.map(input => {
    return /*#__PURE__*/_react.default.createElement("td", {
      key: input.props.name
    }, input);
  });
  return /*#__PURE__*/_react.default.createElement("tr", {
    key: idx
  }, renderRemove({
    idx,
    closeButton
  }), tdedInputs);
});

const renderTable = props => /*#__PURE__*/_react.default.createElement("table", {
  className: props.styles.table
}, /*#__PURE__*/_react.default.createElement("thead", null, renderTableHeader(props)), /*#__PURE__*/_react.default.createElement("tbody", null, renderItems(props)));

const InputArrayTable = props => /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, renderTable(props));

exports.InputArrayTable = InputArrayTable;