"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.InputArrayWrap = exports.renderLectures = void 0;

var _react = _interopRequireWildcard(require("react"));

var _componentRender = require("../componentRender");

var _ducks = require("../ducks");

var _translation_utils = require("../../translation_utils");

var _deletedMark = require("../deletedMark");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function () { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

const renderAddButton = ({
  onAdd,
  styles,
  Button,
  AddGlyph
}) => {
  const boundAdd = e => {
    e.preventDefault();
    onAdd();
  };

  return /*#__PURE__*/_react.default.createElement(Button, {
    onClick: boundAdd,
    styles: styles,
    intent: "add"
  }, /*#__PURE__*/_react.default.createElement(AddGlyph, {
    styles: styles
  }));
};

const renderCloseButton = ({
  onRemove,
  idx,
  styles,
  Button,
  RemoveGlyph
}) => {
  const boundRemove = e => {
    e.preventDefault();
    onRemove(idx);
  };

  return /*#__PURE__*/_react.default.createElement(Button, {
    onClick: boundRemove,
    styles: styles,
    intent: "remove"
  }, /*#__PURE__*/_react.default.createElement(RemoveGlyph, {
    styles: styles
  }));
};

const renderPanelHeader = ({
  onAdd,
  schemaTypeName,
  aliveItems,
  name,
  styles,
  Button,
  AddGlyph,
  Div,
  Text
}) => {
  const addButton = renderAddButton({
    onAdd,
    styles,
    Button,
    AddGlyph
  });
  return /*#__PURE__*/_react.default.createElement(Div, {
    className: styles.inputPanelWrap
  }, /*#__PURE__*/_react.default.createElement(Text, {
    className: styles.inputPanelEntity
  }, (0, _translation_utils.trModel)(schemaTypeName, name) + ' '), addButton);
};

const renderLectures = ({
  error,
  styles,
  Text
}) => {
  if (error && error.message) {
    return /*#__PURE__*/_react.default.createElement(Text, {
      className: styles.error
    }, error.message);
  } else return null;
};
/**
 * Used for the arrays in models, for
 * example clients: [Clients]
 *
 */


exports.renderLectures = renderLectures;

let InputArrayWrap = (_ref) => {
  let {
    name,
    newObject,
    arrayHandler,
    register,
    unregister,
    fieldSchema,
    fieldSchema: {
      type
    },
    schemaTypeName,
    formHook,
    defaultValue,
    errors = {},
    initiallyEmpty,
    onRemove,
    config,
    styles,
    isTable,
    setValue,
    skin
  } = _ref,
      rest = _objectWithoutProperties(_ref, ["name", "newObject", "arrayHandler", "register", "unregister", "fieldSchema", "fieldSchema", "schemaTypeName", "formHook", "defaultValue", "errors", "initiallyEmpty", "onRemove", "config", "styles", "isTable", "setValue", "skin"]);

  const [items, dispatch] = (0, _react.useReducer)(_ducks.inputArray.reducer, _ducks.inputArray.initialFromDefault(defaultValue, initiallyEmpty));
  const schema = type[0];
  const $arrayHandler = arrayHandler;
  const Button = skin.arrayButton.render;
  const AddGlyph = skin.addGlyph.render;
  const RemoveGlyph = skin.removeGlyph.render;
  const Panel = skin.panel.render;
  const Div = skin.div.render;
  const Text = skin.text.render;
  const fieldErrors = errors[name] || {};
  const aliveItems = items.keys.filter(idx => idx !== null);
  const counterField = `${name}__count`;
  const arrayErrors = errors[counterField];

  const getErrorMessage = num => {
    if ('minChildren' in fieldSchema) {
      const {
        minChildren
      } = fieldSchema;
      if (num < minChildren) return (0, _translation_utils.tr)('error.minChildren', {
        minChildren
      });
    }

    if ('maxChildren' in fieldSchema) {
      const {
        maxChildren
      } = fieldSchema;
      if (num > maxChildren) return (0, _translation_utils.tr)('error.maxChildren', {
        maxChildren
      });
    }
  };

  const checkSetErrorMessage = num => {
    const message = getErrorMessage(num);

    if (message) {
      formHook.setError(counterField, {
        type: 'manual',
        message
      });
    } else {
      formHook.clearErrors(counterField);
    }
  };

  const itemsInputs = aliveItems.map(idx => {
    const handleRemove = idx => {
      dispatch(_ducks.inputArray.remove(idx));
      checkSetErrorMessage(items.num - 1);
      const taint = `${name}[${idx}].${_deletedMark.deletedMark}`;
      setValue(taint, true);
      formHook.trigger(counterField);
    };

    const closeButton = renderCloseButton({
      onRemove: handleRemove,
      idx,
      styles,
      Button,
      RemoveGlyph
    });
    let itemDefault;
    if (defaultValue && Array.isArray(defaultValue)) itemDefault = defaultValue[idx];else itemDefault = defaultValue;
    return {
      idx,
      closeButton,
      inputs: (0, _componentRender.renderInputs)(_objectSpread(_objectSpread({}, rest), {}, {
        inline: isTable,
        schema,
        schemaTypeName,
        setValue,
        parent: name,
        index: idx,
        initialValues: itemDefault,
        formHook,
        styles,
        register,
        unregister,
        errors: fieldErrors[idx],
        arrayIdx: idx,
        arrayInitialValues: itemDefault,
        skin
      }))
    };
  });

  const handleAdd = () => {
    formHook.trigger(counterField);
    dispatch(_ducks.inputArray.add());
    checkSetErrorMessage(items.num + 1);
  };

  const panelProps = {
    onAdd: handleAdd,
    schemaTypeName,
    dispatch,
    name,
    styles,
    Button,
    AddGlyph,
    Div,
    Text
  };
  return /*#__PURE__*/_react.default.createElement(Panel, {
    header: renderPanelHeader(panelProps),
    styles: styles
  }, renderLectures({
    styles,
    error: arrayErrors,
    Text
  }), /*#__PURE__*/_react.default.createElement($arrayHandler, _extends({
    schema: schema,
    config: config,
    name: name,
    component: arrayHandler,
    onAdd: handleAdd,
    newObject: newObject,
    items: itemsInputs,
    defaultValue: defaultValue,
    schemaTypeName: schemaTypeName,
    styles: styles,
    skin: skin
  }, rest)));
};

exports.InputArrayWrap = InputArrayWrap;