"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.InputWrap = void 0;

var _react = _interopRequireWildcard(require("react"));

var _translation_utils = require("../../translation_utils");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function () { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

const Wrap = (_ref) => {
  let {
    name,
    children,
    inline,
    styles,
    label
  } = _ref,
      rest = _objectWithoutProperties(_ref, ["name", "children", "inline", "styles", "label"]);

  if (inline) {
    return /*#__PURE__*/_react.default.createElement("div", {
      key: name,
      className: styles.inlineWrap
    }, children);
  } else {
    return /*#__PURE__*/_react.default.createElement("div", _extends({
      key: name,
      className: styles.inputBlockWrap
    }, rest), /*#__PURE__*/_react.default.createElement("label", {
      key: "label",
      htmlFor: name,
      className: styles.label
    }, label), children);
  }
};

let InputWrap = (props, ref) => {
  const {
    name,
    field,
    children,
    schemaTypeName,
    styles,
    labelOverride,
    inline,
    errors = {},
    addWrapperProps
  } = props;
  const label = typeof labelOverride != 'undefined' ? labelOverride : (0, _translation_utils.trField)(props);
  const error = errors[field];
  return /*#__PURE__*/_react.default.createElement(Wrap, _extends({
    name: name,
    inline: inline,
    styles: styles,
    label: label
  }, addWrapperProps), children, error && /*#__PURE__*/_react.default.createElement("div", {
    className: styles.error
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: styles.errorMessage
  }, error.message)));
};

exports.InputWrap = InputWrap;
exports.InputWrap = InputWrap = (0, _react.forwardRef)(InputWrap);