"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _InputWrap = require("./components/InputWrap");

var _RadiosWrap = require("./components/RadiosWrap");

var _Radio = require("./components/Radio");

var _InputArrayWrap = require("./components/InputArrayWrap");

var _InputArrayTable = require("./components/InputArrayTable");

var _InputArrayPanel = require("./components/InputArrayPanel");

var _Select = require("./components/Select");

var _Checkbox = require("./components/Checkbox");

var _Button = require("./components/Button");

var _Panel = require("./components/Panel");

var _RemoveGlyph = require("./svgs/RemoveGlyph");

var _AddGlyph = require("./svgs/AddGlyph");

var _utils = require("../utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function standardClasses(props) {
  return (0, _classnames.default)(props.styles.input, props.styles.standard);
}

var _default = {
  defaultWrap: _InputWrap.InputWrap,
  string: {
    render: props => _objectSpread(_objectSpread({}, props), {}, {
      component: props.fieldSchema.textarea ? 'textarea' : 'input'
    })
  },
  password: {
    render: {
      component: 'input',
      type: 'password'
    }
  },
  number: {
    coerce: value => parseFloat(value),
    render: {
      component: 'input',
      type: 'number'
    }
  },
  range: {
    coerce: value => parseFloat(value),
    render: {
      component: 'input',
      type: 'range'
    }
  },
  radios: {
    render: props => {
      const {
        schemaTypeName,
        field,
        fieldSchema,
        register
      } = props,
            rest = _objectWithoutProperties(props, ["schemaTypeName", "field", "fieldSchema", "register"]);

      const {
        options
      } = fieldSchema;
      const optionsProcessed = (0, _utils.processOptions)(_objectSpread({
        schemaTypeName,
        field,
        options
      }, rest));
      return _objectSpread(_objectSpread({}, rest), {}, {
        schemaTypeName,
        field,
        fieldSchema,
        component: _RadiosWrap.RadiosWrap,
        noRef: true,
        children: optionsProcessed.map(op => {
          return /*#__PURE__*/_react.default.createElement(_Radio.Radio, _extends({}, props, {
            key: op.value,
            option: op.value,
            label: op.label,
            field: props.field,
            ref: register,
            inline: true
          }));
        })
      });
    }
  },
  select: {
    render: {
      component: _Select.Select
    }
  },
  boolean: {
    coerce: value => Boolean(value),
    render: props => {
      const {
        register
      } = props,
            rest = _objectWithoutProperties(props, ["register"]);

      return _objectSpread(_objectSpread({}, rest), {}, {
        ref: register,
        component: _Checkbox.Checkbox,
        inline: true
      });
    }
  },
  button: {
    render: _Button.Button
  },
  arrayButton: {
    render: _Button.Button
  },
  form: {
    render: (_ref) => {
      let {
        children
      } = _ref,
          rest = _objectWithoutProperties(_ref, ["children"]);

      return /*#__PURE__*/_react.default.createElement("form", rest, children);
    }
  },
  panel: {
    render: _Panel.Panel
  },
  addGlyph: {
    render: _AddGlyph.AddGlyph
  },
  removeGlyph: {
    render: _RemoveGlyph.RemoveGlyph
  },
  arrayTable: {
    render: _InputArrayTable.InputArrayTable
  },
  arrayPanel: {
    render: _InputArrayPanel.InputArrayPanel
  },
  div: {
    render: props => /*#__PURE__*/_react.default.createElement("div", props)
  },
  text: {
    render: ({
      children
    }) => children
  }
};
exports.default = _default;